@echo off

if "%1"=="" (
	call :LOG "no parameter"
	goto :EOF
)

setlocal ENABLEDELAYEDEXPANSION

set recpath=t@CpX
set iepgpath=iepg_E[hpX
set rectaskpath=rectaskpX

set dev_t0=BonDriver_PX_W3PE_T0.dll
set dev_t1=BonDriver_PX_W3PE_T1.dll
set dev_s0=BonDriver_PX_W3PE_S0.dll
set dev_s1=BonDriver_PX_W3PE_S1.dll

set rec=%rectaskpath%rectask.exe /rec /chspace 0
set EPOC=719161

for /f "tokens=1-4 delims=: " %%i in ('@type %1') do (
	if /i "%%i"=="station" set sta=%%j
	if /i "%%i"=="year" set year=%%j
	if /i "%%i"=="month" set month=%%j
	if /i "%%i"=="date" set date=%%j
	if /i "%%i"=="start" (
		set sh=%%j
		set sm=%%k
	)
	if /i "%%i"=="end" (
		set eh=%%j
		set em=%%k
	)
	if /i "%%i"=="program-title" set title="%%j%%k%%l"
)

call :TRIM %month% tmonth
call :TRIM %date% tdate
call :TRIM %sh% tsh
call :TRIM %sm% tsm
call :TRIM %eh% teh
call :TRIM %em% tem

call :UT %year% %tmonth% %tdate% %tsh% %tsm% start
call :UT %year% %tmonth% %tdate% %teh% %tem% end

set /A end=%end%-30

if "%sta:~0,3%"=="DFS" call :CHKTIMET %start% %end% device
if "%sta:~1,3%"=="SDT" call :CHKTIMES %start% %end% device

if "%device%"=="na" (	
	echo "no available device"
	pause
	goto :EOF
)

if "%device%"=="T0" set device=%dev_t0%
if "%device%"=="T1" set device=%dev_t1%
if "%device%"=="S0" set device=%dev_s0%
if "%device%"=="S1" set device=%dev_s1%

call :CH %sta% sid ch

if %start% geq %end% set /A end=%end%+(24*60*60) 

set /A dur=%end%-%start%-30

set title=%title:?=%
set title=%title:<=[%
set title=%title:>=]%

c:\windows\system32\schtasks /create /sc once /st %sh%:%sm% /sd %year%/%month%/%date% /tr "%rec% /d %device% /ch %ch% /sid %sid% /recduration %dur% /recfile \"%recpath%%year%%month%%date%_%sh%%sm%_%title%.ts\"" /tn rec_%year%%month%%date%_%sh%%sm%_%RANDOM%

if exist %iepgpath%iepg.tvpid del /f %iepgpath%iepg.tvpid

goto :EOF

:UT 
set /A %6=(365*%1+%1/4-%1/100+%1/400+(306*(%2+1))/10-428+%3-EPOC)*86400+%4*3600+%5*60-205200
goto :EOF

:TRIM
set val=%1
if %val% lss 10 (
	set %2=%val:~1,1%
	) else (
	set %2=%val%
)
goto :EOF

:CH
if "%1"=="DFS00400" set %2=1024& set %3=14& goto :EOF
if "%1"=="DFS00408" set %2=1032& set %3=13& goto :EOF
if "%1"=="DFS00410" set %2=1040& set %3=12& goto :EOF
if "%1"=="DFS00428" set %2=1064& set %3=11& goto :EOF
if "%1"=="DFS00418" set %2=1048& set %3=9& goto :EOF
if "%1"=="DFS00430" set %2=1072& set %3=10& goto :EOF
if "%1"=="DFS00420" set %2=1056& set %3=8& goto :EOF

if "%1"=="BSDT101" set %2=101& set %3=9& goto :EOF
if "%1"=="BSDT103" set %2=103& set %3=10& goto :EOF
if "%1"=="BSDT141" set %2=141& set %3=7& goto :EOF
if "%1"=="BSDT151" set %2=151& set %3=5& goto :EOF
if "%1"=="BSDT161" set %2=161& set %3=1& goto :EOF
if "%1"=="BSDT171" set %2=171& set %3=3& goto :EOF
if "%1"=="BSDT181" set %2=181& set %3=8& goto :EOF
if "%1"=="BSDT191" set %2=191& set %3=2& goto :EOF
if "%1"=="BSDT192" set %2=192& set %3=13& goto :EOF
if "%1"=="BSDT193" set %2=193& set %3=14& goto :EOF
goto :EOF

:CHKTIMET
set t0=a
set t1=a

for /f "tokens=1-24 delims=," %%A in ('@schtasks /query /fo csv /v ^| findstr rec_ ^| findstr E_T') do (
	set reccmd=%%~I
	set ti=%%~U
	set da=%%~V
	for /f "tokens=1-20 delims= " %%f in ('@echo !reccmd!') do (
		set subdur=%%q
		set tuner=%%k
		set tuner=!tuner:~18,-4!
	)
	for /f "tokens=1,2 delims=:" %%a in ('@echo !ti!') do (
		set hr=%%a& set mi=%%b
		call :TRIM !hr! th
		call :TRIM !mi! tm
	)
	for /f "tokens=1,2,3 delims=-" %%c in ('@echo !da!') do (
		set ye=%%c& set mo=%%d& set da=%%e
		call :TRIM !mo! tmo
		call :TRIM !da! tda
	)
	call :UT !ye! !tmo! !tda! !th! !tm! substa
	set /A subend=!substa!+!subdur!

	if %1 geq !substa! (
		if %1 leq !subend! (
			if "!tuner!"=="T0" set t0=na
			if "!tuner!"=="T1" set t1=na
		)
	)			
	if %2 geq !substa! (
		if %2 leq !subend! (
			if "!tuner!"=="T0" set t0=na
			if "!tuner!"=="T1" set t1=na
		)
	)
)

if "%t0%"=="a" set %3=T0& goto:EOF
if "%t1%"=="a" set %3=T1& goto:EOF
set %3=na
goto :EOF


:CHKTIMES
set s0=a
set s1=a

for /f "tokens=1-24 delims=," %%A in ('@schtasks /query /fo csv /v ^| findstr rec_ ^| findstr E_S') do (
	set reccmd=%%~I
	set ti=%%~U
	set da=%%~V
	for /f "tokens=1-20 delims= " %%f in ('@echo !reccmd!') do (
		set subdur=%%q
		set tuner=%%k
		set tuner=!tuner:~18,-4!
	)
	for /f "tokens=1,2 delims=:" %%a in ('@echo !ti!') do (
		set hr=%%a& set mi=%%b
		call :TRIM !hr! th
		call :TRIM !mi! tm
	)
	for /f "tokens=1,2,3 delims=-" %%c in ('@echo !da!') do (
		set ye=%%c& set mo=%%d& set da=%%e
		call :TRIM !mo! tmo
		call :TRIM !da! tda
	)
	call :UT !ye! !tmo! !tda! !th! !tm! substa
	set /A subend=!substa!+!subdur!

	if %1 geq !substa! (
		if %1 leq !subend! (
			if "!tuner!"=="S0" set s0=na
			if "!tuner!"=="S1" set s1=na
		)
	)			
	if %2 geq !substa! (
		if %2 leq !subend! (
			if "!tuner!"=="S0" set s0=na
			if "!tuner!"=="S1" set s1=na
		)
	)
)

if "%s0%"=="a" set %3=S0& goto:EOF
if "%s1%"=="a" set %3=S1& goto:EOF
set %3=na
goto :EOF


:LOG
c:\windows\system32\eventcreate.exe /t error /id 100 /l Application /so recsche.cmd /d %1




